From 25ed783082f0a1a733a033606f03288ed8ee4493 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 05 2020 02:22:07 +0000
Subject: [PATCH 1664/2232] Allow Box containing shared type from other module


#541, but for Box in addition to Vec.

---

diff --git a/syntax/check.rs b/syntax/check.rs
index 21a8515..e9d977b 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -76,6 +76,7 @@ fn check_type_ident(cx: &mut Check, ident: &Ident) {
 fn check_type_box(cx: &mut Check, ptr: &Ty1) {
     if let Type::Ident(ident) = &ptr.inner {
         if cx.types.cxx.contains(&ident.rust)
+            && !cx.types.aliases.contains_key(&ident.rust)
             && !cx.types.structs.contains_key(&ident.rust)
             && !cx.types.enums.contains_key(&ident.rust)
         {
@@ -329,6 +330,7 @@ fn check_api_type(cx: &mut Check, ety: &ExternType) {
             TrivialReason::StructField(strct) => format!("a field of `{}`", strct.name.rust),
             TrivialReason::FunctionArgument(efn) => format!("an argument of `{}`", efn.name.rust),
             TrivialReason::FunctionReturn(efn) => format!("a return value of `{}`", efn.name.rust),
+            TrivialReason::BoxTarget => format!("Box<{}>", ety.name.rust),
             TrivialReason::VecElement => format!("a vector element in Vec<{}>", ety.name.rust),
         };
         let msg = format!(
diff --git a/syntax/types.rs b/syntax/types.rs
index e2f5bf8..1b61cdb 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -202,9 +202,16 @@ impl<'a> Types<'a> {
             }
         }
         for ty in &all {
-            if let Type::RustVec(ty) = ty {
-                let reason = TrivialReason::VecElement;
-                insist_alias_types_are_trivial(&ty.inner, reason);
+            match ty {
+                Type::RustBox(ty) => {
+                    let reason = TrivialReason::BoxTarget;
+                    insist_alias_types_are_trivial(&ty.inner, reason);
+                }
+                Type::RustVec(ty) => {
+                    let reason = TrivialReason::VecElement;
+                    insist_alias_types_are_trivial(&ty.inner, reason);
+                }
+                _ => {}
             }
         }
 
@@ -303,6 +310,7 @@ pub enum TrivialReason<'a> {
     StructField(&'a Struct),
     FunctionArgument(&'a ExternFn),
     FunctionReturn(&'a ExternFn),
+    BoxTarget,
     VecElement,
 }
 

